/*
https://stackoverflow.com/questions/20617067/returning-function-pointer-type/20617529

http://c-faq.com/decl/spiral.anderson.html
*/
#include <stdio.h>

int sq(int x){return x * x;}
int cb(int y){return y * y * y;}

int (*ch(int z,
         int(*f1)(int),
         int(*f2)(int)))(int)
{
   return (z < 0) ? f1 : f2;
}

int f(int w)
{
   return ch(w, sq, cb)(w);
}

int main()
{
   printf("r1 = %d\n", f(-3));
   printf("r2 = %d\n", f( 3));
   printf("r3 = %d\n", f(-1));
}

/*
(prog
  (fun sq (lambda x (* x x)))
  (fun cb (lambda y (* y y y)))
  (fun ch (lambda z f1 f2 (if (< z 0) f1 f2)))
  (fun f  (lambda w (apply (apply ch w sq cb) w))) // sq neg num and cube pos num
  (var r1 (apply f -3))
  (var r2 (apply f  3))
  (var r3 (apply f -1))
)
*/
